(*****************************************************************************)
(*///////////////////////////////////////////////////////////////////////////*)
(*///////////////////////////////////////////////////////////////////////////*)
(*///*********************************************************************///*)
(*///*                                                                   *///*)
(*///*                          R A T   v0.01h                           *///*)
(*///*                                                                   *///*)
(*///*        A Turbo-Pascal v5.5 / 5.0 interface to RemoteAccess        *///*)
(*///*                                                                   *///*)
(*///*                   NOT UPDATED TO RA 2.50 YET!!                    *///*)
(*///*                                                                   *///*)
(*///*                NON-PUBLIC TURBO-PASCAL SOURCE CODE                *///*)
(*///*                ===================================                *///*)
(*///*********************************************************************///*)
(*///////////////////////////////////////////////////////////////////////////*)
(*///////////////////////////////////////////////////////////////////////////*)
(*===========================================================================*)
(*                 Copyright (C) 1989 by Continental Software                *)
(*                           All Rights Reserved                             *)
(*****************************************************************************)

Unit RAT;

{$IFDEF OVL}
  {$F+,O+}
{$ELSE}
  {$F-,O-}
{$ENDIF}

{$IFDEF BETA}
  {$I+,R+,S+}
{$ELSE}
  {$I-,R-,S-}
{$ENDIF}

{$I-}           (* $I- becuase error checking (RATStatus) is done *)

Interface

Uses DOS;

  const
    CR           = #$0D;
    SoftCR       = #$8D;
    LF           = #$0A;
    RATVersion   = '0.01h (TP)';
    RATName      = 'RemoteAccess Tools (RAT) ' + RATVersion + ', Copyright (C) 1989 by Continental Software.';
    MonthName    : Array[1..12] of String[3] = ('Jan','Feb','Mar','Apr',
                                                'May','Jun','Jul','Aug',
                                                'Sep','Oct','Nov','Dec');

  type
    MsgType    = (Local, NetMail, EchoMail);
    FlagType   = Array[1..4] of Byte;
    Time       = String[5];
    Date       = String[8];
    LongDate   = String[9];

    NetNode    = Record
      Zone,
      Net,
      Node   : Word;
    end;

    NetAddress = record
      Zone,
      Net,
      Node,
      Point  : Word;
    end;

    MSGINFOrecord = Record
      LowMsg,
      HighMsg,
      TotalMsgs    : Word;
      TotalOnBoard : Array[1..200] of Word;
    end;

    MSGIDXrecord = Record
      MsgNum : Integer;
      Board  : Byte;
    end;

    MSGTOIDXrecord = String[35];




    MSGHDRrecord = Record
      MsgNum     : Integer;
      PrevReply,
      NextReply,
      TimesRead  : Word;
      StartBlock : Word;
      NumBlocks,
      DestNet,
      DestNode,
      OrigNet,
      OrigNode   : Word;
      DestZone,
      OrigZone   : Byte;
      Cost       : Word;
      MsgAttr,
        {
  1       Bit 0: Deleted
  2       Bit 1: Unmoved Outgoing Net Message
  4       Bit 2: Is a Net Mail Message
  8       Bit 3: Private
  16      Bit 4: Received
          Bit 5: Unmoved Outgoing Echo Message
          Bit 6: Local Bit
          Bit 7: [ Reserved ]
        }
      NetAttr,
        {
          Bit 0: Kill/sent
          Bit 1: Sent
          Bit 2: File Attach
          Bit 3: Crash
          Bit 4: Request Receipt
          Bit 5: Audit Request
          Bit 6: Is a Return Receipt
          Bit 7: [ Reserved ]
        }
      Board      : Byte;
      PostTime   : Time;
      PostDate   : Date;
      WhoTo,
      WhoFrom    : MSGTOIDXrecord;
      Subject    : String[72];
    end;

    MSGTXTrecord   = String[255];

    USERONrecord = Record
      Name         : MSGTOIDXrecord;
      Line         : Byte;
      Baud         : Word;
      City         : String[25];
      DoNotDisturb : Boolean;
    end;

    LASTCALLrecord = Record
      Line       : Byte;
      Name       : MSGTOIDXrecord;
      City       : String[25];
      Baud       : Word;
      Times      : Longint;
      LogOn      : String[5];
      LogOff     : String[5];
    end;

  USERSrecord = Record
    Name          : MSGTOIDXrecord;
    Location      : String[25];
    Password      : String[15];
    DataPhone,
    VoicePhone    : String[12];
    LastTime      : Time;
    LastDate      : Date;
    Attribute     : Byte;
    Flags         : FlagType;
    Credit,
    Pending       : Word;
    MsgsPosted,
    LastRead,
    Security,
    NoCalls,
    Uploads,
    Downloads,
    UploadsK,
    DownloadsK    : Word;
    TodayK,
    Elapsed       : Integer;
    ScreenLength  : Word;
    LastPwdChange,
    Attribute2    : Byte;
    ExtraSpace    : Array[1..6] of Byte;
  end;


   SYSINFOrecord = Record
     TotalCalls  : LongInt;
     LastCaller  : MSGTOIDXrecord;
     ExtraSpace  : Array[1..128] of Byte;
   end;

   TIMELOGrecord = Record
     StartDate   : Date;
     BusyPerHour : Array[0..23] of Word;
     BusyPerDay  : Array[0..6] of Word;
   end;

   MNUrecord = Record
     Typ        : Byte;
     Security   : Word;
     Flags      : FlagType;
     Display    : String[75];
     HotKey     : Char;
     MiscData   : String[80];
     Foreground,
     Background : Byte;
   end;

  LASTREADrecord = Array[1..200] of Word;

  COMBINEDrecord = Array[1..25] of Byte;

  AskType     = (Yes, No, Ask);

  EVENTrecord = Record
    Status      : Byte; { 0=Deleted 1=Enabled 2=Disabled }
    StartTime   : Time;
    ErrorLevel  : Byte;
    Days        : Byte;
    Forced      : Boolean;
    LastTimeRun : Date;
  end;

  EVENTrecordArray = Array[1..20] of EVENTrecord;

  MsgKindsType  = (Both, Private, Public, ROnly);

  MESSAGErecord = Record
    Name          : String[40];
    Typ           : MsgType;
    MsgKinds      : MsgKindsType;
    Aliases       : Boolean;

    DaysKill,             { Kill older than 'x' days }
    RecvKill      : Byte; { Kill recv msgs, recv for more than 'x' days }
    CountKill     : Word;

    ReadSecurity  : Word;
    ReadFlags     : FlagType;

    WriteSecurity : Word;
    WriteFlags    : FlagType;

    SysopSecurity : Word;
    SysopFlags    : FlagType;

    OriginLine    : String[60];
    AkaAddress    : Byte;
  end;

  FILESrecord = Record
    Name            : String[30];
    Typ             : Byte;       { 0=Fido 1=TBBS 2=Lynx }
    FilePath,                     { C:\FILES\UPLOADS\ }
    ListPath        : String[40]; { FILES.BBS / FILES.DIR etc.. }

    Security        : Word;
    Flags           : FlagType;

    PrivateSecurity : Word;     { Sec to send/view/download private files }
    PrivateFlags    : FlagType; { with a '/' as 1st char in description.  }
  end;

  {$I RACONFIG.INC}

  EXITINFOrecord = Record
    Baud            : Word;
    SysInfo         : SYSINFOrecord;
    TimeLogInfo     : TIMELOGrecord;
    UserInfo        : USERSrecord;
    EventInfo       : EVENTrecord;
    NetMailEntered,
    EchoMailEntered : Boolean;
    LoginTime       : Time;
    LoginDate       : Date;
    TimeLimit       : Word;
    LoginSec,
    Credit          : LongInt;
    UserRecord      : Integer;
    ReadThru        : Word;
    NumberPages     : Word;
    DownloadLimit   : Word;
    TimeOfCreation  : Time;
  end;

  PROTOCOLrecord = Record
    Name            : String[15];
    ActiveKey       : Char;
    OpusTypeCtlFile,
    BatchAvailable  : Boolean;
    Attribute       : Byte;   { 0=Disabled, 1=Enabled }
    LogFileName,
    CtlFileName,
    DnCmdString,
    DnCtlString,
    UpCmdString,
    UpCtlString     : String[80];
    UpLogKeyword,
    DnLogKeyword    : String[20];
    XferDescWordNum,
    XferNameWordNum : Byte;
  end;

  PROTOCOLfile = File of PROTOCOLrecord;

  SYSINFOfile  = File of SYSINFOrecord;

  TIMELOGfile  = File of TIMELOGrecord;

  USERONfile   = File of USERONrecord;

  LASTCALLfile = File of LASTCALLrecord;

  EXITINFOfile = File of EXITINFOrecord;

  USERSfile    = File;

  LASTREADfile = File;

  COMBINEDfile = File;

  CONFIGfile   = File of CONFIGrecord;

  FILESfile    = File of FILESrecord;

  MESSAGEfile  = File of MESSAGErecord;

  EVENTfile    = File of EVENTrecordArray;

  MSGfiles     = Record
                   INFO     : File of MSGINFOrecord;
                   IDX      : File;
                   HDR      : File;
                   TOIDX    : File;
                   TXT      : File;
                   MSGINFO  : MSGINFOrecord;
                 end;

  var
    RATStatus       : Word;               { IOResult-type status indicator       }
    RATCurrentUserHook : Pointer;         { Current user procedure pointer       }
    RATMsgNum      : Integer;             { Temporay value used by DeleteMessage }


  Function RATOK : Boolean;
  Function Bit (Data : Byte;
               BitNo : Byte) : Boolean;
  Procedure AConvert (OldAddr : String;
                  var NewAddr : NetNode;
                  DefaultAddr : NetNode);
  Function AddrStr (Addr : NetAddress) : String;

  Procedure CreateUserFile(var USERS : USERSfile);
  Procedure OpenUserFile(var USERS : USERSfile);
  Procedure ReadUser (var USERS : USERSfile;
                  var USERSinfo : USERSrecord;
                       RecordNo : Longint);
  Procedure WriteUser (var USERS : USERSfile;
                       USERSinfo : USERSrecord;
                        RecordNo : Longint);
  Procedure FindUser (var USERS : USERSfile;
                       Username : MSGTOIDXrecord;
                   var RecordNo : LongInt);
  Procedure DeleteUser (var USERS : USERSfile;
                         RecordNo : LongInt);
  Procedure CloseUserFile (var USERS : USERSfile);

  Procedure CreateLastReadFile (var LASTREAD : LASTREADfile);

  Procedure OpenLastReadFile (var LASTREAD : LASTREADfile);

  Procedure ReadLastRead (var LASTREAD : LASTREADfile;
                      var LASTREADinfo : LASTREADrecord;
                              RecordNo : Longint);

  Procedure WriteLastRead (var LASTREAD : LASTREADfile;
                           LASTREADinfo : LASTREADrecord;
                               RecordNo : Longint);

  Procedure CloseLastRead (var LASTREAD : LASTREADfile);

  Procedure CreateCombinedFile (var COMBINED : COMBINEDfile);

  Procedure OpenCOMBINEDFile (var COMBINED : COMBINEDfile);

  Procedure ReadCOMBINED (var COMBINED : COMBINEDfile;
                      var COMBINEDinfo : COMBINEDrecord;
                              RecordNo : Longint);

  Procedure WriteCOMBINED (var COMBINED : COMBINEDfile;
                           COMBINEDinfo : COMBINEDrecord;
                               RecordNo : Longint);

  Procedure CloseCOMBINED (var COMBINED : COMBINEDfile);

  Procedure RebuildUserFiles (var USERS : USERSfile;
                           var COMBINED : COMBINEDfile; DoComb  : Boolean;
                           var LASTREAD : LASTREADfile; DoLread : Boolean);

  Procedure OpenMsgFiles (var MSG : MSGfiles);

  Procedure WriteMSGINFO (var MSG : MSGfiles);

  Procedure ReadMSGINFO (var MSG : MSGfiles);

  Procedure WriteMsgIdx (var MSG : MsgFiles;
                      MSGIDXinfo : MSGIDXrecord;
                        RecordNo : LongInt);

  Procedure ReadMsgHdr (var MSG : MsgFiles;
                 var MSGHDRinfo : MSGHDRrecord;
                       RecordNo : LongInt);

  Procedure WriteMsgHdr (var MSG : MsgFiles;
                      MSGHDRinfo : MSGHDRrecord;
                        RecordNo : LongInt);

  Procedure ReadMsgToIdx (var MSG : MsgFiles;
                 var MSGTOIDXinfo : MSGTOIDXrecord;
                         RecordNo : LongInt);

  Procedure ReadMsgIdx (var MSG : MsgFiles;
                 var MSGIDXinfo : MSGIDXrecord;
                       RecordNo : LongInt);

  Function MessageDeleted (var MSG : MSGfiles;
                          RecordNo : LongInt) : Boolean;

  Function MessageReceived (var MSG : MSGfiles;
                           RecordNo : LongInt) : Boolean;

  Procedure ScanMSGIDXforward (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

  Procedure ScanMSGIDXreverse (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

  Procedure ScanMSGTOIDXforward (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

  Procedure ScanMSGTOIDXreverse (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

  Procedure ScanMSGHDRforward (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

  Procedure ScanMSGHDRreverse (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

  Procedure ReadMsgTxt  (var MSG : MSGfiles;
                      MSGHDRinfo : MSGHDRrecord;
                        UserFunc : Pointer;
                       DispWidth : Byte;
                        RecordNo : LongInt;
                      DispHidden : Boolean);

  Procedure WriteMsgTxt  (var MSG : MSGfiles;
                   var MSGHDRinfo : MSGHDRrecord;
                         UserHook : Pointer;
                         RecordNo : LongInt);

  Function NewMsgRecordNo (var MSG : MSGfiles) : LongInt;

  Procedure WriteNewMsg (var MSG : MSGfiles;
                      MSGHDRinfo : MSGHDRrecord;
                        UserHook : Pointer);

  Procedure DeleteMessage (var MSG : MSGfiles;
                          RecordNo : LongInt);

  Procedure CloseMsgFiles (var MSG : MSGfiles);


  Function CurrentTime : Time;

  Function CurrentDate : Date;

  Function DisplayDate(NormDate : Date) : LongDate;

  Procedure ReadSysInfo (var SYSINFO : SYSINFOfile;
                 var SYSINFOinfo : SYSINFOrecord);

  Procedure WriteSysInfo (var SYSINFO : SYSINFOfile;
                      SYSINFOinfo : SYSINFOrecord);

  Procedure ReadTimeLog (var TIMELOG : TIMELOGfile;
                     var TIMELOGinfo : TIMELOGrecord);

  Procedure WriteTimeLog (var TIMELOG : TIMELOGfile;
                      TIMELOGinfo : TIMELOGrecord);

  Procedure ReadConfigInfo (var CONFIG : CONFIGfile;
                    var CONFIGinfo : CONFIGrecord);

  Procedure WriteConfigInfo (var CONFIG : CONFIGfile;
                         CONFIGinfo : CONFIGrecord);

  Procedure ReadExitinfoFile (var EXITINFO : EXITINFOfile;
                      var EXITINFOinfo : EXITINFOrecord);

  Procedure WriteExitinfoFile (var EXITINFO : EXITINFOfile;
                           EXITINFOinfo : EXITINFOrecord);


  Procedure WriteUserOn (var USERON : USERONfile;
                         USERONinfo : USERONrecord;
                               Line : Byte);

  Procedure WriteLastCall (var LASTCALL : LASTCALLfile;
                           LASTCALLinfo : LASTCALLrecord);

  Procedure ReadUserOn (var USERON : USERONfile;
                    var USERONinfo : USERONrecord;
                              Line : Byte);

  Procedure ReadLastCall (var LASTCALL : LASTCALLfile;
                      var LASTCALLinfo : LASTCALLrecord;
                             CallerNum : Byte);

  Procedure WriteMESSAGErec (var MESSAGE : MESSAGEfile;
                             MESSAGEinfo : MESSAGErecord;
                                RecordNo : Byte);

  Procedure ReadMESSAGErec (var MESSAGE : MESSAGEfile;
                        var MESSAGEinfo : MESSAGErecord;
                               RecordNo : Byte);

  Procedure WriteFILESrec (var FILES : FILESfile;
                           FILESinfo : FILESrecord;
                            RecordNo : Byte);

  Procedure ReadFILESrec (var FILES : FILESfile;
                      var FILESinfo : FILESrecord;
                           RecordNo : Byte);

  Procedure WritePROTOCOLrec (var PROTOCOL : PROTOCOLfile;
                              PROTOCOLinfo : PROTOCOLrecord;
                                  RecordNo : Byte);

  Procedure ReadPROTOCOLrec (var PROTOCOL : PROTOCOLfile;
                         var PROTOCOLinfo : PROTOCOLrecord;
                                 RecordNo : Byte);

  Function CallReadMsgTxtHook (TxtLine : String) : Boolean;
    Inline($FF/$1E/RATCurrentUserHook);

  Function CallWriteMsgTxtHook (var TxtLine : String) : Boolean;
    Inline($FF/$1E/RATCurrentUserHook);

Implementation

  Function RATOK : Boolean;

    begin
      RATStatus := IOResult;
      RATOK := ((RATStatus = 0) or (RATStatus = 5));
    end;

  Procedure AConvert (OldAddr : String;
                  var NewAddr : NetNode;
                  DefaultAddr : NetNode);

    var
      Zone, Net, Node       : String[5];

    begin
      if Pos(':',OldAddr) > 0 then Zone := Copy(OldAddr,1,Pos(':',OldAddr) -1)
                              else Zone := '';
      OldAddr := Copy(OldAddr,Pos(':',OldAddr) +1, Length(OldAddr) - Pos(':',OldAddr) );

      If Pos('/',OldAddr) > 0 then Net  := Copy(OldAddr,1,Pos('/',OldAddr) -1)
                              else Net  := '';
      OldAddr := Copy(OldAddr,Pos('/',OldAddr) +1, Length(OldAddr) - Pos('/',OldAddr) );

      Node := OldAddr;

      If (Zone = '') then NewAddr.Zone := DefaultAddr.Zone
                     else Val(Zone,NewAddr.Zone,RATStatus);
      If (Net  = '') then NewAddr.Net  := DefaultAddr.Net
                     else Val(Net,NewAddr.Net,RATStatus);
      If (Node = '') then NewAddr.Node := DefaultAddr.Node
                     else Val(Node,NewAddr.Node,RATStatus);
    end;

  Function AddrStr (Addr : NetAddress) : String;

    var
      AddSt                  : String;
      Zone, Net, Node, Point : String[5];

    begin
      Str(Addr.Zone,Zone);
      Str(Addr.Net,Net);
      Str(Addr.Node,Node);
      Str(Addr.Point,Point);
      AddSt := Zone + ':' + Net + '/' + Node;
      If Addr.Point <> 0 then AddSt := AddSt + '.' + Point;
      AddrStr := AddSt;
    end;

  Function Bit (Data : Byte;
               BitNo : Byte) : Boolean;

    begin
      Bit := NOT ((Data shr BitNo mod 2) = 0);
    end;

  Procedure CreateUserFile (var USERS : USERSfile);

    begin
      Rewrite (USERS, SizeOf(USERSrecord));
      If RATOK then Seek (USERS,0);
    end;

  Procedure OpenUserFile(var USERS : USERSfile);

    begin
      FileMode := 2;
      Reset (USERS, SizeOf(USERSrecord));
      If RATOK then Seek (USERS,0);
    end;

  Procedure ReadUser (var USERS : USERSfile;
                  var USERSinfo : USERSrecord;
                       RecordNo : Longint);
    begin
      Seek (USERS, RecordNo);
      If RATOK then
        begin
          BlockRead (USERS, USERSinfo, 1);
          RATStatus := IOResult;
        end;
    end;

  Procedure FindUser (var USERS : USERSfile;
                       Username : MSGTOIDXrecord;
                   var RecordNo : LongInt);
    label
      FinishScan;

    const
      BufferSize = 25;

    type
      Buff          = Array[1..BufferSize] of USERSrecord;

    var
      Counter       : LongInt;
      USERSbuff     : ^Buff;
      RecRead       : Word;

    begin
      New (USERSbuff);
      RecordNo := 0;

      BlockRead (USERS, USERSbuff^, 1);
      RecRead := 1;
      Counter := 1;
      If (UserName = USERSbuff^[RecRead].Name) then goto FinishScan;

      While not EOF(USERS) do
        begin
          BlockRead (USERS, USERSbuff^, BufferSize, RecRead);

          For Counter := 1 to RecRead do
            If (UserName = USERSbuff^[Counter].Name) then goto FinishScan;
        end;

      RecordNo := -1;

      FinishScan:

      If RecordNo <> -1 then RecordNo := (FilePos(USERS) - RecRead + Counter -1);
      Dispose (USERSbuff);
    end;


  Procedure WriteUser (var USERS : USERSfile;
                       USERSinfo : USERSrecord;
                        RecordNo : Longint);

    begin
      If (RecordNo = -1) then RecordNo := FileSize(USERS);
      Seek (USERS, RecordNo);
      BlockWrite (USERS, USERSinfo, 1);
      RATStatus := IOResult;
    end;


  Procedure DeleteUser (var USERS : USERSfile;
                         RecordNo : LongInt);

    var
      USERSinfo    : USERSrecord;

    begin
      ReadUser (USERS, USERSinfo, RecordNo);
      If (RATStatus = 0) then
        begin
          If not Bit(USERSinfo.Attribute,1) then Inc(USERSinfo.Attribute);
          WriteUser (USERS, USERSinfo, RecordNo);
        end;
    end;


  Procedure CloseUserFile (var USERS : USERSfile);

    begin
      Close (USERS);
    end;


  Procedure CreateLastReadFile (var LASTREAD : LASTREADfile);

    begin
      Rewrite (LASTREAD, SizeOf(LASTREADrecord));
      If RATOK then Seek (LASTREAD, 0);
    end;


  Procedure OpenLastReadFile (var LASTREAD : LASTREADfile);

    begin
      FileMode := 2;
      Reset (LASTREAD, SizeOf(LASTREADrecord));
      If RATOK then Seek (LASTREAD, 0);
    end;


  Procedure ReadLastRead (var LASTREAD : LASTREADfile;
                      var LASTREADinfo : LASTREADrecord;
                              RecordNo : Longint);

    begin
      Seek (LASTREAD, RecordNo);
      If RATOK then
        begin
          BlockRead (LASTREAD, LASTREADinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Procedure WriteLastRead (var LASTREAD : LASTREADfile;
                           LASTREADinfo : LASTREADrecord;
                               RecordNo : Longint);

    begin
      If (RecordNo = -1) then RecordNo := FileSize(LASTREAD);
      Seek (LASTREAD, RecordNo);
      BlockWrite (LASTREAD, LASTREADinfo, 1);
      RATStatus := IOResult;
    end;


  Procedure CloseLastRead (var LASTREAD : LASTREADfile);

    begin
      Close (LASTREAD);
    end;


  Procedure RebuildUserFiles (var USERS : USERSfile;
                           var COMBINED : COMBINEDfile; DoComb  : Boolean;
                           var LASTREAD : LASTREADfile; DoLread : Boolean);
    const
      BufferSize   = 20;

    type
      USERSbuff    = Array[1..BufferSize] of USERSrecord;
      COMBINEDbuff = Array[1..BufferSize] of COMBINEDrecord;
      LASTREADbuff = Array[1..bufferSize] of LASTREADrecord;

    var
      USERSinfo    : ^USERSbuff;
      COMBINEDinfo : ^COMBINEDbuff;
      LASTREADinfo : ^LASTREADbuff;
      RecsRead     : Word;
      Counter      : Word;
      Counter2     : Byte;
      CombON       : COMBINEDrecord;

    begin
      New (USERSinfo);
      New (COMBINEDinfo);
      New (LASTREADinfo);
      FillChar (CombON, SizeOf(CombON), 255);

      If DoLread then Rewrite(LASTREAD, SizeOf(LASTREADrecord));
      If DoComb then Rewrite(COMBINED, SizeOf(COMBINEDrecord));

      repeat
        BlockRead(USERS, USERSinfo^, BufferSize, RecsRead);

        If RecsRead > 0 then
          begin
            For Counter := 1 to RecsRead do
              begin
                If DoComb then COMBINEDinfo^[Counter] := CombON;
                If DoLread then For Counter2 := 1 to 200 do
                  LASTREADinfo^[Counter][Counter2] := USERSinfo^[Counter].Lastread;
              end;
            If DoComb then BlockWrite (COMBINED, COMBINEDinfo^, RecsRead);
             If DoLread then BlockWrite (LASTREAD, LASTREADinfo^, RecsRead);
          end;
      until EOF(USERS);

      Dispose (USERSinfo);
      Dispose (COMBINEDinfo);
      Dispose (LASTREADinfo);
    end;


  Procedure CreateCOMBINEDFile (var COMBINED : COMBINEDfile);

    begin
      Rewrite (COMBINED, SizeOf(COMBINEDrecord));
      If RATOK then Seek (COMBINED, 0);
    end;

  Procedure OpenCOMBINEDFile (var COMBINED : COMBINEDfile);

    begin
      FileMode := 2;
      Reset (COMBINED, SizeOf(COMBINEDrecord));
      If RATOK then Seek (COMBINED, 0);
    end;

  Procedure ReadCOMBINED (var COMBINED : COMBINEDfile;
                      var COMBINEDinfo : COMBINEDrecord;
                              RecordNo : Longint);

    begin
      Seek (COMBINED, RecordNo);
      If RATOK then
        begin
          BlockRead (COMBINED, COMBINEDinfo, 1);
          RATStatus := IOResult;
        end;
    end;

  Procedure WriteCOMBINED (var COMBINED : COMBINEDfile;
                           COMBINEDinfo : COMBINEDrecord;
                               RecordNo : Longint);

    begin
      If (RecordNo = -1) then RecordNo := FileSize(COMBINED);
      Seek (COMBINED, RecordNo);
      BlockWrite (COMBINED, COMBINEDinfo, 1);
      RATStatus := IOResult;
    end;

  Procedure CloseCOMBINED (var COMBINED : COMBINEDfile);

    begin
      Close (COMBINED);
    end;

  Procedure OpenMsgFiles (var MSG : MSGfiles);

    begin
      FileMode := 2;
      Reset (MSG.INFO);
      If not RATOK then
        begin
          RATStatus := RATStatus + (255 * 1);
          Exit;
        end;
      Read (MSG.INFO,MSG.MSGINFO);

      FileMode := 2;
      Reset (MSG.IDX, SizeOf(MSGIDXrecord));
      If not RATOK then
        begin
          RATStatus := RATStatus + (255 * 2);
          Exit;
        end;

      FileMode := 2;
      Reset (MSG.HDR, SizeOf(MSGHDRrecord));
      If not RATOK then
        begin
          RATStatus := RATStatus + (255 * 3);
          Exit;
        end;

      FileMode := 2;
      Reset (MSG.TOIDX, SizeOf(MSGTOIDXrecord));
      If not RATOK then
        begin
          RATStatus := RATStatus + (255 * 4);
          Exit;
        end;

      FileMode := 2;
      Reset (MSG.TXT, SizeOf(MSGTXTrecord));
      If not RATOK then
        begin
          RATStatus := RATStatus + (255 * 5);
          Exit;
        end;
    end;


  Procedure WriteMSGINFO (var MSG : MSGfiles);

    begin
      FileMode := 2;
      With MSG.MSGINFO do
        begin
          If TotalMsgs <= 0 then
            begin
              TotalMsgs := 0;
              HighMsg   := 0;
              LowMsg    := 0;
            end;
          If HighMsg < 0 then HighMsg := 0;
          If LowMsg < 0 then LowMsg := 0;
        end;
      Seek(MSG.INFO, 0);
      Write (MSG.INFO, MSG.MSGINFO);
    end;


  Procedure ReadMSGINFO (var MSG : MSGfiles);

    begin
      Seek (MSG.INFO, 0);
      Read (MSG.INFO, MSG.MSGINFO);
    end;


  Procedure CloseMsgFiles (var MSG : MSGfiles);

    begin
      With MSG do
        begin
          Close (INFO);
          Close (IDX);
          Close (HDR);
          Close (TOIDX);
          Close (TXT);
        end;
    end;


  Procedure ReadMsgIdx (var MSG : MsgFiles;
                 var MSGIDXinfo : MSGIDXrecord;
                       RecordNo : LongInt);
    begin
      Seek(MSG.IDX, RecordNo);
      If RATOK then
        begin
          BlockRead(MSG.IDX, MSGIDXinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Procedure WriteMsgIdx (var MSG : MsgFiles;
                      MSGIDXinfo : MSGIDXrecord;
                        RecordNo : LongInt);
    begin
      Seek(MSG.IDX, RecordNo);
      If RATOK then
        begin
          BlockWrite(MSG.IDX, MSGIDXinfo, 1);
          RATStatus := IOResult;
        end;
    end;

  Procedure ReadMsgHdr (var MSG : MsgFiles;
                 var MSGHDRinfo : MSGHDRrecord;
                       RecordNo : LongInt);
    begin
      Seek(MSG.HDR, RecordNo);
      If RATOK then
        begin
          BlockRead(MSG.HDR, MSGHDRinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Procedure WriteMsgHdr (var MSG : MsgFiles;
                      MSGHDRinfo : MSGHDRrecord;
                        RecordNo : LongInt);
    begin
      Seek(MSG.HDR, RecordNo);
      If RATOK then
        begin
          BlockWrite(MSG.HDR, MSGHDRinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Procedure ReadMsgToIdx (var MSG : MsgFiles;
                 var MSGTOIDXinfo : MSGTOIDXrecord;
                         RecordNo : LongInt);
    begin
      Seek(MSG.TOIDX, RecordNo);
      If RATOK then
        begin
          BlockRead(MSG.TOIDX, MSGTOIDXinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Procedure WriteMsgToIdx (var MSG : MsgFiles;
                      MSGTOIDXinfo : MSGTOIDXrecord;
                          RecordNo : LongInt);
    begin
      Seek(MSG.TOIDX, RecordNo);
      If RATOK then
        begin
          BlockWrite(MSG.TOIDX, MSGTOIDXinfo, 1);
          RATStatus := IOResult;
        end;
    end;


  Function MessageDeleted (var MSG : MSGfiles;
                          RecordNo : LongInt) : Boolean;

    var
      MSGIDXinfo : MSGIDXrecord;

    begin
      ReadMsgIdx (MSG, MSGIDXinfo, RecordNo);
      MessageDeleted := (MSGIDXinfo.MsgNum = -1)
    end;


  Function MessageReceived (var MSG : MSGfiles;
                           RecordNo : LongInt) : Boolean;

    var
      MSGHDRinfo : MSGHDRrecord;

    begin
      ReadMsgHdr (MSG, MSGHDRinfo, RecordNo);
      MessageReceived := Bit(MSGHDRinfo.MsgAttr,4)
    end;


  Function TestMSGTOIDX (MSGTOIDXinfo : MSGTOIDXrecord) : Boolean;

    Inline($FF/$1E/RATCurrentUserHook);


  Procedure ScanMSGTOIDXforward (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGTOIDXrecord;

    var
      Counter       : LongInt;
      MSGTOIDXbuff  : ^Buff;
      RecRead       : Word;
      BytesRead     : LongInt;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGTOIDXbuff);
      RecordNo := 0;

      repeat
        BlockRead (MSG.TOIDX, MSGTOIDXbuff^, BufferSize, RecRead);

        For Counter := 1 to RecRead do
          If TestMSGTOIDX(MSGTOIDXbuff^[Counter]) then goto FinishScan;
      until (EOF(MSG.TOIDX)) or (IOResult <> 0);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.TOIDX) - RecRead + Counter -1;
      Seek (MSG.TOIDX, RecordNo +1); { '+1' - move to next item }
      Dispose(MSGTOIDXbuff);
    end;


  Procedure ScanMSGTOIDXreverse (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGTOIDXrecord;

    var
      Counter       : Word;
      MSGTOIDXbuff  : ^Buff;
      RecRead       : Word;
      StartRec      : Word;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGTOIDXbuff);
      RecordNo := 0;

      repeat
        If FilePos(MSG.TOIDX) <= BufferSize then Seek(MSG.TOIDX, 0)
                                            else Seek(MSG.TOIDX, FilePos(MSG.TOIDX)-BufferSize);

        BlockRead (MSG.TOIDX, MSGTOIDXbuff^, BufferSize, RecRead);

        For Counter := 1 to RecRead do
          If TestMSGTOIDX(MSGTOIDXbuff^[RecRead+1-Counter]) then goto FinishScan;
      until (FilePos(MSG.TOIDX) = 0);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.TOIDX) - RecRead + Counter -1;
      Seek (MSG.TOIDX, RecordNo -1); { '-1' - move to previous item }
      Dispose(MSGTOIDXbuff);
    end;


  Function TestMSGIDX (MSGIDXinfo : MSGIDXrecord) : Boolean;

    Inline($FF/$1E/RATCurrentUserHook);


  Procedure ScanMSGIDXforward (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGIDXrecord;

    var
      Counter       : LongInt;
      MSGIDXbuff    : ^Buff;
      RecRead       : Word;
      BytesRead     : LongInt;
      Temp          : LongInt;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGIDXbuff);
      RecordNo := 0;

      repeat
       BlockRead (MSG.IDX, MSGIDXbuff^, BufferSize, RecRead);

       For Counter := 1 to RecRead do
       begin
         If TestMSGIDX(MSGIDXbuff^[Counter]) then goto FinishScan;
       end;
      until EOF(MSG.IDX);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.IDX) - RecRead + Counter -1;

      Temp := FilePos(MSG.IDX);

      Seek (MSG.IDX, RecordNo +1); { '+1' - move to next item }
      Dispose(MSGIDXbuff);
    end;


  Procedure ScanMSGIDXreverse (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGIDXrecord;

    var
      Counter       : Word;
      MSGIDXbuff    : ^Buff;
      RecRead       : Word;
      ReadRec       : Word;
      Temp:Word;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGIDXbuff);
      RecordNo := 0;

      repeat
        If FilePos(MSG.IDX) < BufferSize then
          begin
            ReadRec := FilePos(MSG.IDX)+1;
            Seek(MSG.IDX, 0);
          end
        else
          begin
            Seek(MSG.IDX, FilePos(MSG.IDX)-BufferSize+1);
            ReadRec := BufferSize;
          end;

        BlockRead (MSG.IDX, MSGIDXbuff^, ReadRec, RecRead);

        For Counter := 1 to RecRead do
        begin
          If TestMSGIDX(MSGIDXbuff^[RecRead+1-Counter]) then goto FinishScan;
        end;
        if FilePos(MSG.IDX) - RecRead >= 0 then Seek (MSG.IDX, FilePos(MSG.IDX)-RecRead);
      until (FilePos(MSG.IDX) = 0);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.IDX) - Counter;

      Seek (MSG.IDX, RecordNo -1); { '-1' - move to previous item }
      Dispose(MSGIDXbuff);
    end;


  Function TestMSGHDR (MSGHDRinfo : MSGHDRrecord) : Boolean;

    Inline($FF/$1E/RATCurrentUserHook);


  Procedure ScanMSGHDRforward (var MSG : MSGfiles;
                                UserHook : Pointer;
                            var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGHDRrecord;

    var
      Counter       : LongInt;
      MSGHDRbuff    : ^Buff;
      RecRead       : Word;
      BytesRead     : LongInt;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGHDRbuff);
      RecordNo := 0;

      repeat
       BlockRead (MSG.HDR, MSGHDRbuff^, BufferSize, RecRead);

       For Counter := 1 to RecRead do
       begin
         If TestMSGHDR(MSGHDRbuff^[Counter]) then goto FinishScan;
       end;
      until EOF(MSG.HDR);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.HDR) - RecRead + Counter -1;
      Seek (MSG.HDR, RecordNo +1); { '+1' - move to next item }
      Dispose(MSGHDRbuff);
    end;


  Procedure ScanMSGHDRreverse (var MSG : MSGfiles;
                              UserHook : Pointer;
                          var RecordNo : LongInt);

    label
      FinishScan;

    const
      BufferSize = 50;

    type
      Buff          = Array[1..BufferSize] of MSGHDRrecord;

    var
      Counter       : Word;
      MSGHDRbuff    : ^Buff;
      RecRead       : Word;
      ReadRec       : Word;
      Temp:Word;

    begin
      RATCurrentUserHook := UserHook;
      New(MSGHDRbuff);
      RecordNo := 0;

      repeat
        If FilePos(MSG.HDR) < BufferSize then
          begin
            ReadRec := FilePos(MSG.HDR)+1;
            Seek(MSG.HDR, 0);
          end
        else
          begin
            Seek(MSG.HDR, FilePos(MSG.HDR)-BufferSize+1);
            ReadRec := BufferSize;
          end;

        BlockRead (MSG.HDR, MSGHDRbuff^, ReadRec, RecRead);

        For Counter := 1 to RecRead do
        begin
          If TestMSGHDR(MSGHDRbuff^[RecRead+1-Counter]) then goto FinishScan;
        end;
        if FilePos(MSG.HDR) - RecRead >= 0 then Seek (MSG.HDR, FilePos(MSG.HDR)-RecRead);
      until (FilePos(MSG.HDR) = 0);

      RecordNo := -1;

      FinishScan:

      If (RecordNo <> -1) then RecordNo := FilePos(MSG.HDR) - Counter;

      Seek (MSG.HDR, RecordNo -1); { '-1' - move to previous item }
      Dispose(MSGHDRbuff);
    end;


{  Procedure CallReadMsgTxtHook (TxtLine : String) : Boolean;
    Inline($FF/$1E/RATCurrentUserHook);}


  Procedure ReadMsgTxt  (var MSG : MSGfiles;
                      MSGHDRinfo : MSGHDRrecord;
                        UserFunc : Pointer;
                       DispWidth : Byte;
                        RecordNo : LongInt;
                      DispHidden : Boolean);
    var
      MSGTXTinfo   : MSGTXTrecord;
      BlockCounter : LongInt;
      ChCounter    : Word;
      TxtLine      : String;
      TxtWord      : String;

    begin
      RATCurrentUserHook := UserFunc;
      TxtLine := '';
      TxtWord := '';
      Seek (MSG.TXT, MSGHDRinfo.StartBlock);

      For BlockCounter := 1 to MSGHDRinfo.NumBlocks do
        begin
          BlockRead (MSG.TXT, MSGTXTinfo, 1);
          For ChCounter := 1 to Length(MSGTXTinfo) do
            begin
              Case MSGTXTinfo[ChCounter] of
                  CR     : begin
                             TxtLine := TxtLine + TxtWord;
                             TxtWord := '';
                             If not ((not DispHidden) and (TxtLine[1] = #1)) then
                               If CallReadMsgTxtHook(TxtLine) then Exit;
                             TxtLine := '';
                           end;
                  ' '    : begin
                             TxtLine := TxtLine + TxtWord;
                             TxtWord := ' ';
                           end;
                  LF,
                  SoftCR : ;
                  else     begin
                             If (TxtWord = '') and (TxtLine <> '')
                               then TxtWord := ' ' + MSGTXTinfo[ChCounter]
                               else TxtWord := TxtWord + MSGTXTinfo[ChCounter];
                             If (Length(TxtLine+TxtWord) >= DispWidth) then
                               begin
                                 If not ((not DispHidden) and (TxtLine[1] = #1)) then
                                   If CallReadMsgTxtHook(TxtLine) then Exit;
                                 TxtLine := '';
                                 If (TxtWord[1] = ' ') then TxtWord := Copy(TxtWord, 2, Length(TxtWord)-1);
                               end;
                           end;
                end;
            end;
        end;
    end;

{  Procedure CallWriteMsgTxtHook (var TxtLine : String);
    Inline($FF/$1E/RATCurrentUserHook);}

  Procedure WriteMsgTxt  (var MSG : MSGfiles;
                   var MSGHDRinfo : MSGHDRrecord;
                         UserHook : Pointer;
                         RecordNo : LongInt);
    var
      Counter      : Byte;
      MSGTXTinfo   : MSGTXTrecord;
      Finished     : Boolean;
      TxtLine      : String;
      OldLength    : Byte;
      MSGTXTbuff   : Array[1..50] of ^MSGTXTrecord;
      BlockNo      : Byte;

    begin
      BlockNo := 0;
      RATCurrentUserHook := UserHook;
      MSGTXTinfo := '';

      If CallWriteMsgTxtHook (TxtLine) then Exit;
      While (TxtLine <> #0) do
        begin
          OldLength := Length(MSGTXTinfo);

          While (Pos(CR, TxtLine) > 0) do Delete(TxtLine, Pos(CR, TxtLine), 1);
                 { Remove all CR's }

          While (Pos(LF, TxtLine) > 0) and ( (Pos(' * Origin:', TxtLine) = 0)
           or (Pos(LF,TxtLine) < Pos(' * Origin:',TxtLine) - 1) )   do
          Begin
            Delete(TxtLine, Pos(LF, TxtLine), 1);
          End;
                 { Remove all LF's except immediately preceding Origin Line}

          If TxtLine[Length(TxtLine)] <> SoftCR then TxtLine := TxtLine + CR;
                 { Add a CR if there is no SoftCR }

          MSGTXTinfo := MSGTXTinfo + TxtLine;

          If (OldLength + Length(TxtLine) > 255) then { Line exceeded current block }
            begin
              Inc(BlockNo);
              New(MSGTXTbuff[BlockNo]);
              MSGTXTbuff[BlockNo]^ := MSGTXTinfo;
              MSGTXTinfo := Copy(TxtLine, (256 - OldLength), Length(TxtLine) - (255 - OldLength));
            end;
          If CallWriteMsgTxtHook (TxtLine) then
          begin
            For Counter := 1 to BlockNo do
            begin
              Dispose (MSGTXTbuff[Counter]);
            end;
            Exit;
          end;
        end;

      If (MSGTXTinfo <> '') then
        begin
          Inc(BlockNo);
          New(MSGTXTbuff[BlockNo]);
          MSGTXTbuff[BlockNo]^ := MSGTXTinfo;
        end;

      If (BlockNo > MSGHDRinfo.NumBlocks) then MSGHDRinfo.StartBlock := 0;
      If (MSGHDRinfo.StartBlock = 0) then MSGHDRinfo.StartBlock := FileSize(MSG.TXT);
      MSGHDRinfo.NumBlocks := BlockNo;

      Seek (MSG.TXT, MSGHDRinfo.StartBlock);
      For Counter := 1 to BlockNo do
        begin
          BlockWrite (MSG.TXT, MSGTXTbuff[Counter]^, 1);
          Dispose (MSGTXTbuff[Counter]);
        end;
    end;


  Function CurrentTime : Time;

    var
      HourStr,
      MinStr   : String[2];
      Hour,
      Min,
      Sec,
      T        : Word;

    begin
      GetTime(Hour,Min,Sec,T);
      Str(Hour,HourStr);
      Str(Min,MinStr);
      If Min < 10 then MinStr := '0'+MinStr;
      If Hour < 10 then HourStr := '0'+HourStr;
      CurrentTime := HourStr + ':' + MinStr;
    end;


  Function CurrentDate: Date;

    var
      Year,
      Month,
      Day,
      DayOfWeek : Word;
      YearStr   : String[2];
      DayStr    : String[2];
      MonthName : String[2];

    begin
      GetDate(Year,Month,Day,DayofWeek);
      Str(Year-1900,YearStr);
      Str(Month,MonthName);
      Str(Day,DayStr);
      If Month < 10 then MonthName := '0' + MonthName;
      If Day < 10 then DayStr := '0' + DayStr;
      CurrentDate := MonthName + '-' + DayStr + '-' + YearStr;
    end;


  Function DisplayDate (NormDate : Date) : LongDate;

    var
      Month    : Byte;
      Scratch  : Word;

    begin
      Val(Copy(NormDate,4,2), Month,  Scratch);
      If (Month < 1) or (Month > 12) or (Scratch <> 0) then DisplayDate := 'Invalid  '
        else
          DisplayDate := Copy(NormDate,1,3) + MonthName[Month] + Copy(NormDate,6,3);
    end;


  Function NewMsgRecordNo (var MSG : MSGfiles) : LongInt;

    begin
      NewMsgRecordNo := FileSize(MSG.IDX);
    end;


  Procedure WriteNewMsg (var MSG : MSGfiles;
                      MSGHDRinfo : MSGHDRrecord;
                        UserHook : Pointer);
    var
      MSGIDXinfo   : MSGIDXrecord;
      Counter      : LongInt;
      MsgRecord    : LongInt;
      RecordNo     : LongInt;
      MSGTOIDXinfo : MSGTOIDXrecord;

    begin
      RecordNo := NewMsgRecordNo (MSG);

      With MSGHDRinfo do
        begin
          MsgNum     := MSG.MSGINFO.HighMsg + 1;
          StartBlock := 0;
          NumBlocks  := 0;
          PostDate   := CurrentDate;
          PostTime   := CurrentTime;
        end;
      With MSGIDXinfo do
        begin
          Board    := MSGHDRinfo.Board;
          MsgNum   := MSGHDRinfo.MsgNum;
        end;
      MSGTOIDXinfo := MSGHDRinfo.WhoTo;

      WriteMsgTxt (MSG, MSGHDRinfo, UserHook, RecordNo);
      WriteMsgIdx (MSG, MSGIDXinfo, RecordNo);
      WriteMsgHdr (MSG, MSGHDRinfo, RecordNo);
      WriteMsgToIdx (MSG, MSGTOIDXinfo, RecordNo);

      Inc(MSG.MSGINFO.TotalOnBoard[MSGIDXinfo.Board]);
      Inc(MSG.MSGINFO.TotalMsgs);
      MSG.MSGINFO.HighMsg := MSGIDXinfo.MsgNum;
      If (MSG.MSGINFO.TotalMsgs = 1) or (MSG.MSGINFO.LowMsg = 0)
        then MSG.MSGINFO.LowMsg := MSGIDXinfo.MsgNum;
      WriteMsgInfo(MSG);
    end;

  Function TestMsgNotDeleted (MSGIDXinfo : MSGIDXrecord) : Boolean;

    begin
      TestMsgNotDeleted := (MSGIDXinfo.MsgNum >= 0);
    end;

  Function TestMsgNum (MSGIDXinfo : MSGIDXrecord) : Boolean;

    begin
      TestMsgNum := (MSGIDXinfo.MsgNum = RATMsgNum);
    end;

  Procedure DeleteMessage (var MSG : MSGfiles;
                           RecordNo: LongInt);

    var
      MSGHDRinfo,
      MSGHDRnext,
      MSGHDRprev : MSGHDRrecord;
      MSGIDXinfo : MSGIDXrecord;
      AdjustHDR,
      AdjustIDX,
      AdjustNext,
      AdjustPrev  : Boolean;
      StartRecordNo,
      NextRecordNo,
      PrevRecordNo : LongInt;

    begin
      AdjustHDR  := True;
      AdjustIDX  := True;
      AdjustNext := False;
      AdjustPrev := False;

      StartRecordNo := RecordNo;
      ReadMSGHDR (MSG, MSGHDRinfo, RecordNo);
      If (not odd(MSGHDRinfo.MsgAttr)) and (MSGHDRinfo.MsgNum >= 0) then
        begin
          Inc(MSGHDRinfo.MsgAttr);
        end
      else AdjustHDR := False;

      ReadMSGIDX (MSG, MSGIDXinfo, RecordNo);
      If (MSGIDXinfo.MsgNum >= 0) then
        begin
          MSGIDXinfo.MsgNum  := -1;
        end
      else
        AdjustIDX := False;

      If AdjustIDX then WriteMsgIdx (MSG, MSGIDXinfo, RecordNo);
      If AdjustHDR then WriteMsgHdr (MSG, MSGHDRinfo, RecordNo);

      If (AdjustHDR and AdjustIDX) then With MSG.MSGINFO do
        begin
          Dec(TotalMsgs);
          Dec(TotalOnBoard[MSGIDXinfo.Board]);

          If (LowMsg = MSGIDXinfo.MsgNum) then
            begin
              Seek (MSG.IDX, 0);
              ScanMSGIDXforward(MSG, @TestMsgNotDeleted, RecordNo);
              If (RecordNo = -1) then LowMsg := 0
                else
                  begin
                    ReadMSGIDX (MSG, MSGIDXinfo, RecordNo);
                    LowMsg := MSGIDXinfo.MsgNum;
                  end;
            end;

          If (HighMsg = MSGIDXinfo.MsgNum) then
            begin
              Seek (MSG.IDX, FileSize(MSG.IDX));
              ScanMSGIDXreverse(MSG, @TestMsgNotDeleted, RecordNo);
              If (RecordNo = -1) then LowMsg := 0
                else
                  begin
                    ReadMSGIDX (MSG, MSGIDXinfo, RecordNo);
                    HighMsg := MSGIDXinfo.MsgNum;
                  end;
            end;
        end;

      If (MSGHDRinfo.NextReply > 0) then
        begin
          RATMsgNum := MSGHDRinfo.NextReply;
          Seek(MSG.IDX, 0);
          ScanMSGIDXforward (MSG, @TestMsgNum, RecordNo);
          ReadMSGHDR (MSG, MSGHDRnext, RecordNo);
          NextRecordNo := RecordNo;
        end;

      If (MSGHDRinfo.PrevReply > 0) then
        begin
          RATMsgNum := MSGHDRinfo.PrevReply;
          ScanMSGIDXreverse (MSG, @TestMsgNum, RecordNo);
          ReadMSGHDR (MSG, MSGHDRprev, RecordNo);
          PrevRecordNo := RecordNo;
        end;


      Case (MSGHDRinfo.NextReply > 0) of
        True  : Case (MSGHDRinfo.PrevReply > 0) of
                  True  : begin
                            MSGHDRprev.NextReply := MSGHDRnext.MsgNum;
                            MSGHDRnext.PrevReply := MSGHDRprev.MsgNum;
                            AdjustNext := True;
                            AdjustPrev := True;
                          end;
                  False : begin
                            MSGHDRnext.PrevReply := 0;
                            AdjustNext := True;
                          end;
                end;
        False : Case (MSGHDRinfo.PrevReply > 0) of
                  True  : begin
                            MSGHDRprev.NextReply := 0;
                            AdjustPrev := True;
                          end;
                  False :
                end;
      end;
      if (AdjustNext) and (NextRecordNo >= 0) and (NextRecordNo < FileSize(MSG.HDR))
       then WriteMsgHdr(MSG, MSGHDRnext, NextRecordNo);
      if (AdjustPrev) and (PrevRecordNo >= 0) and (PrevRecordNo < FileSize(MSG.HDR))
       then WriteMsgHdr(MSG, MSGHDRprev, PrevRecordNo);
      RecordNo := StartRecordNo;
      Seek(MSG.IDX, RecordNo);
      Seek(MSG.HDR, RecordNo);
    end;


  Procedure ReadSysInfo (var SYSINFO : SYSINFOfile;
                     var SYSINFOinfo : SYSINFOrecord);

    begin
      FileMode := 2;
      Reset (SYSINFO);
      If RATOK then
        begin
          Read (SYSINFO, SYSINFOinfo);
          RATStatus := IOResult;
          Close (SYSINFO);
        end;
    end;


  Procedure WriteSysInfo (var SYSINFO : SYSINFOfile;
                          SYSINFOinfo : SYSINFOrecord);

    begin
      Rewrite (SYSINFO);
      If RATOK then
        begin
          Write (SYSINFO, SYSINFOinfo);
          RATStatus := IOResult;
          Close (SYSINFO);
        end;
    end;


  Procedure ReadTimeLog (var TIMELOG : TIMELOGfile;
                     var TIMELOGinfo : TIMELOGrecord);

    begin
      FileMode := 2;
      Reset (TIMELOG);
      If RATOK then
        begin
          Read (TIMELOG, TIMELOGinfo);
          RATStatus := IOResult;
          Close (TIMELOG);
        end;
    end;


  Procedure WriteTimeLog (var TIMELOG : TIMELOGfile;
                          TIMELOGinfo : TIMELOGrecord);

    begin
      Rewrite (TIMELOG);
      If RATOK then
        begin
          Write (TIMELOG, TIMELOGinfo);
          RATStatus := IOResult;
          Close (TIMELOG);
        end;
    end;


  Procedure ReadConfigInfo (var CONFIG : CONFIGfile;
                        var CONFIGinfo : CONFIGrecord);

    begin
      FileMode := 2;
      Reset (CONFIG);
      If RATOK then
        begin
          Read (CONFIG, CONFIGinfo);
          RATStatus := IOResult;
          Close (CONFIG);
        end;
    end;


  Procedure WriteConfigInfo (var CONFIG : CONFIGfile;
                             CONFIGinfo : CONFIGrecord);

    begin
      Rewrite (CONFIG);
      If RATOK then
        begin
          Write (CONFIG, CONFIGinfo);
          RATStatus := IOResult;
        end;
    end;


  Procedure ReadExitinfoFile (var EXITINFO : EXITINFOfile;
                          var EXITINFOinfo : EXITINFOrecord);

    begin
      FileMode := 2;
      Reset (EXITINFO);
      If RATOK then
        begin
          Read (EXITINFO, EXITINFOinfo);
          RATStatus := IOResult;
          Close (EXITINFO);
        end;
    end;


  Procedure WriteExitinfoFile (var EXITINFO : EXITINFOfile;
                               EXITINFOinfo : EXITINFOrecord);

    begin
      Rewrite (EXITINFO);
      If RATOK then
        begin
          Write (EXITINFO, EXITINFOinfo);
          RATStatus := IOResult;
          Close (EXITINFO);
        end;
    end;


  Procedure WriteLastCall (var LASTCALL : LASTCALLfile;
                           LASTCALLinfo : LASTCALLrecord);

    begin
      FileMode := 2;
      Reset(LASTCALL);
      If not RATOK then Rewrite(LASTCALL);
      Seek(LASTCALL,FileSize(LASTCALL));
      Write(LASTCALL, LASTCALLinfo);
      Close(LASTCALL);
    end;


  Procedure ReadUserOn (var USERON : USERONfile;
                    var USERONinfo : USERONrecord;
                              Line : Byte);

    begin
      FileMode := 2;
      Reset (USERON);

      If not RATOK then Exit;
      Seek(USERON, Line -1);
      Read(USERON,UserOnInfo);
      Close(USERON);
    end;


  Procedure ReadLastCall (var LASTCALL : LASTCALLfile;
                      var LASTCALLinfo : LASTCALLrecord;
                             CallerNum : Byte);

    begin
      FileMode := 2;
      Reset(LASTCALL);
      Seek(LASTCALL, CallerNum);
      Read(LASTCALL, LASTCALLinfo);
      Close(LASTCALL);
    end;


  Procedure WriteUserOn (var USERON : USERONfile;
                         USERONinfo : USERONrecord;
                               Line : Byte);
    begin
      FileMode := 2;
      Reset (USERON);

      if IOResult <> 0 then
        begin
          Rewrite(USERON);
          RATStatus := IOResult;
          If RATStatus <> 0 then Exit;
        end;

      Seek(USERON, Line -1);
      Write(USERON,UserOnInfo);
      Close(USERON);
    end;


  Procedure WriteMESSAGErec (var MESSAGE : MESSAGEfile;
                             MESSAGEinfo : MESSAGErecord;
                                RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (MESSAGE);
      If not RATOK then
        begin
          Rewrite(MESSAGE);
          If not RATOK then Exit;
        end;

      Seek (MESSAGE, RecordNo);
      Write (MESSAGE, MESSAGEinfo);
      Close (MESSAGE);
    end;


  Procedure ReadMESSAGErec (var MESSAGE : MESSAGEfile;
                        var MESSAGEinfo : MESSAGErecord;
                               RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (MESSAGE);
      If not RATOK then Exit;

      Seek(MESSAGE, RecordNo);
      Read(MESSAGE, MESSAGEinfo);
      Close(MESSAGE);
    end;

  Procedure WriteFILESrec (var FILES : FILESfile;
                           FILESinfo : FILESrecord;
                            RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (FILES);
      If not RATOK then
        begin
          Rewrite(FILES);
          If not RATOK then Exit;
        end;

      Seek (FILES, RecordNo);
      Write (FILES, FILESinfo);
      Close (FILES);
    end;


  Procedure ReadFILESrec (var FILES : FILESfile;
                      var FILESinfo : FILESrecord;
                           RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (FILES);
      If not RATOK then Exit;

      Seek (FILES, RecordNo);
      Read (FILES, FILESinfo);
      Close (FILES);
    end;


  Procedure WritePROTOCOLrec (var PROTOCOL : PROTOCOLfile;
                              PROTOCOLinfo : PROTOCOLrecord;
                                  RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (PROTOCOL);
      If not RATOK then
        begin
          Rewrite(PROTOCOL);
          If not RATOK then Exit;
        end;

      Seek (PROTOCOL, RecordNo);
      Write (PROTOCOL, PROTOCOLinfo);
      Close (PROTOCOL);
    end;

  Procedure ReadPROTOCOLrec (var PROTOCOL : PROTOCOLfile;
                         var PROTOCOLinfo : PROTOCOLrecord;
                                 RecordNo : Byte);

    begin
      FileMode := 2;
      Reset (PROTOCOL);
      If not RATOK then Exit;

      Seek (PROTOCOL, RecordNo);
      Read (PROTOCOL, PROTOCOLinfo);
      Close (PROTOCOL);
    end;


  { Initialisation code }
  end.
